/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A rule governing the accesibility of a vault from a specific ip address or
 * ip range.
 *
 */
class IPRule {
  /**
   * Create a IPRule.
   * @member {string} value An IPv4 address range in CIDR notation, such as
   * '124.56.78.91' (simple IP address) or '124.56.78.0/24' (all addresses that
   * start with 124.56.78).
   */
  constructor() {
  }

  /**
   * Defines the metadata of IPRule
   *
   * @returns {object} metadata of IPRule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IPRule',
      type: {
        name: 'Composite',
        className: 'IPRule',
        modelProperties: {
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IPRule;
