/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Log specification of operation.
 *
 */
class LogSpecification {
  /**
   * Create a LogSpecification.
   * @member {string} [name] Name of log specification.
   * @member {string} [displayName] Display name of log specification.
   * @member {string} [blobDuration] Blob duration of specification.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LogSpecification
   *
   * @returns {object} metadata of LogSpecification
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogSpecification',
      type: {
        name: 'Composite',
        className: 'LogSpecification',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          blobDuration: {
            required: false,
            serializedName: 'blobDuration',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LogSpecification;
