/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of the vault access policy
 *
 */
class VaultAccessPolicyProperties {
  /**
   * Create a VaultAccessPolicyProperties.
   * @member {array} accessPolicies An array of 0 to 16 identities that have
   * access to the key vault. All identities in the array must use the same
   * tenant ID as the key vault's tenant ID.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VaultAccessPolicyProperties
   *
   * @returns {object} metadata of VaultAccessPolicyProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VaultAccessPolicyProperties',
      type: {
        name: 'Composite',
        className: 'VaultAccessPolicyProperties',
        modelProperties: {
          accessPolicies: {
            required: true,
            serializedName: 'accessPolicies',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AccessPolicyEntryElementType',
                  type: {
                    name: 'Composite',
                    className: 'AccessPolicyEntry'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VaultAccessPolicyProperties;
